<?php

/**
 * Form builder. Configure XMPP server settings.
 *
 * @ingroup forms
 * @see system_settings_form().
 */
function xmpp_server_admin_settings() {
  $form = array();

  $form['xmpp_server_port'] = array(
    '#type' => 'textfield',
    '#title' => t('XMPP Server port'),
    '#description' => t('The port that your XMPP server will run on. (Default is 5222.)'),
    '#default_value' => variable_get('xmpp_server_port', 5222),
    '#size' => 5,
  );

  $form['xmpp_server_cache_lists'] = array(
    '#type' => 'checkbox',
    '#title' => t('List caching'),
    '#description' => t('Set whether or not the XMPP server should cache it\'s roster or presence lists. (May hinder development.)'),
    '#default_value' => variable_get('xmpp_server_cache_lists', false),
  );

  $running = (variable_get('xmpp_server_ping', 0) > time() - 10) && variable_get('xmpp_server_running', false);

  $form['xmpp_server_running'] = array(
    '#type' => 'checkbox',
    '#title' => t('Running'),
    '#description' => t('Set whether or not the XMPP Server should continue running. (Only for stopping the server.)'),
    '#default_value' => $running,
  );

  return system_settings_form($form);
}

