<?php

function dbg($text) {
  global $ini;
  if($ini['debug'] == 'true')
    echo "Debug: $text\n";
}

function modules_event() {
  $args = func_get_args();
  return call_user_method_array("DoCallback", ModuleManager::Singleton(), $args);
}

class ModuleManager {
  private $dir;
  private $modules = array();
  private $modulenames = array();

  function __construct($modules) {
    $this->modulenames = $modules;
    self::$_singleton = $this;
  }

  function Init($dir) {
    foreach($this->modulenames as $mod) {
      include_once("{$dir}/{$mod}.inc");
      $this->modules[$mod] = new Module($mod);
    }

    $results = $this->DoCallback("init");
    foreach($results as $mod => $value) {
      if($value === false) {
        unset($this->modules[$mod]);
      }
    }
  }

  function DoCallback($callback) {
    $ret = array();
    foreach($this->modules as $mod) {
      $args = func_get_args();
      array_shift($args);
      $ret[$mod->name] = $mod->Callback($callback, $args);
    }
    return $ret;
  }

  static function Singleton() {
    return self::$_singleton;
  }

  static private $_singleton;
}

class Module {
  public $name;
  
  function __construct($name) {
    $this->name = $name;
  }

  function Callback($func, $args) {
    $func = "xmpp_{$this->name}_{$func}";
    if(function_exists($func)) {
      return call_user_func_array($func, $args);
    }
  }
}

