<?php

function xmpp_disco_xml() {
  global $ini;
  $funcs = array();
  
  $funcs['disco_query'] = array(
    'auth' => true,
    'filters' => array(
      'tag' => 'iq',
      'options' => array(
        'type' => 'get',
        'to' => "?{$ini['host']}",
      ),
      'children' => array(
        'query' => array(
          'tag' => 'query',
          'options' => array(
            'xmlns' => 'http://jabber.org/protocol/disco#info',
          ),
        ), //End of 'query' tag definition
      ),
    ), //End of 'iq' tag definition
  );

  $funcs['disco_items'] = array(
    'auth' => true,
    'filters' => array(
      'tag' => 'iq',
      'options' => array(
        'type' => 'get',
        'to' => "?{$ini['host']}",
      ),
      'children' => array(
        'query' => array(
          'tag' => 'query',
          'options' => array(
            'xmlns' => 'http://jabber.org/protocol/disco#items',
          ),
        ),
      ),
    ),
  );

  return $funcs;
}

function xmpp_disco_disco_features() {
  return array(
    'http://jabber.org/protocol/disco#info', 
    'http://jabber.org/protocol/disco#items',
  );
}

function disco_query($node, $s) {
  global $ini;
  $iq = new XmlNode('iq', array(
    'type' => 'result', 
    'from' => $ini['host'], 
    'id' => $node->options['id'],
    'to' => $s->jid->Serialize())
  );

  $features = modules_event("disco_features", $s);
  $identities = modules_event("disco_identities", $s);

  //print_r($features); print_r($identities);

  foreach($identities as $mod => $identityset) {
    if(!is_array($identityset))
      continue;
      
    foreach($identityset as $identity) {
      $i = new XmlNode('identity', $identity);
      $iq->AddChild($i);
    }
  }
  foreach($features as $mod => $featureset) {
    if(!is_array($featureset))
      continue;
      
    foreach($featureset as $feature) {
      $f = new XmlNode('feature', array('var' => $feature));
      $iq->AddChild($f);
    }
  }

  $s->Send($iq->Serialize());
}

function disco_items($node, $s) {
  global $ini;
  $iq = new XmlNode('iq', array(
    'type' => 'result',
    'from' => $ini['host'],
    'to' => $s->jid->Serialize(),
    'id' => $node->options['id'])
  );

  $q = new XmlNode('query', array('xmlns' => 'http://jabber.org/protocol/disco#items'));

  $items = modules_event("disco_items");

  foreach($items as $mod => $itemset) {
    if(!is_array($itemset))
      continue;

    foreach($itemset as $item) {
      $q->AddChild($item);
    }
  }

  $iq->AddChild($q);
  $s->Send($iq->Serialize());
}

