<?php

function xmpp_session_features($s) {
  if(!$s->authorized)
    return;

  $bind = new XmlNode('bind', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-bind'));
  $session = new XmlNode('session', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-session'));

  return array($bind, $session);
}

function xmpp_session_xml() {
  global $ini;
  $funcs = array();

  $funcs['new_xmpp_session'] = array(
    'auth' => true,
    'filters' => array(
      'tag' => 'iq',
      'options' => array(
        'id' => '*',
        'type' => 'set',
      ),
      'children' => array(
        'session' => array(
          'tag' => 'session',
          'options' => array(
            'xmlns' => 'urn:ietf:params:xml:ns:xmpp-session',
          ),
        ),
      ),
    ),
  );

  $funcs['bind_resource'] = array(
    'unbound' => true,
    'auth' => true,
    'filters' => array(
      'tag' => 'iq',
      'options' => array(
        'type' => 'set',
      ),
      'children' => array(
        'bind' => array(
          'tag' => 'bind',
          'options' => array(
            'xmlns' => 'urn:ietf:params:xml:ns:xmpp-bind',
          ),
        ),
      ),
    ),
  );

  return $funcs;
}

function new_xmpp_session($node, $s) {
  global $ini;
  $res = new XmlNode('iq', 
    array('from' => $ini['host'], 
      'type' => 'result', 
      'id' => $node->options['id']));

  $s->Send($res->Serialize());
}

function bind_resource($node, $s) {
  $resource = $node->children['bind']->children['resource']->data;

  if(empty($resource)) {
    $resource = "Home";
  }

  $iq = new XmlNode('iq', array(
      'to' => $s->jid->Serialize(), 
      'type' => 'result', 
      'id' => $node->options['id'])
  );

  $bind = new XmlNode('bind', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-bind'));
  $jid = new XmlNode('jid');
  $jid->data = $s->jid->Serialize();

  $bind->AddChild($jid);
  $iq->AddChild($bind);
  
  $s->Send($iq->Serialize());

  $s->bound = true;
  

  modules_event("user_bind", $s);
}

