<?php

function xmpp_stream_new_session($s) {
}

function xmpp_stream_xml() {
  global $ini;
  return array(
    'stream_start' => array(
      'unbound' => true,
      'op' => 'open',
      'filters' => array(
        'tag' => 'stream:stream',
        'options' => array(
          'xmlns' => 'jabber:client',
          'xmlns:stream' => 'http://etherx.jabber.org/streams',
          'to' => $ini['host'],
        ),
      ),
    ),
    'stream_stop' => array(
      'unbound' => true,
      'op' => 'close',
      'filters' => array(
        'tag' => 'stream:stream',
      ),
    ),
  );
}

function stream_start($node, $s) {
  global $ini;
  $s->stream = $node;

  $stream = new XmlNode('stream:stream');
  $stream->options['xmlns'] = 'jabber:client';
  $stream->options['xmlns:stream'] = 'http://etherx.jabber.org/streams';
  $stream->options['id'] = $s->Id();
  $stream->options['from'] = $ini['host'];
  $stream->options['version'] = '1.0';

  $s->Send($stream->Serialize('open'));

  $modules = modules_event("features", $s);
  $f = new XmlNode('stream:features');

  foreach($modules as $features) {
    if(is_object($features))
      $features = array($features);
    if(!is_array($features))
      $features = array();
    foreach($features as $feature)
      $f->AddChild($feature);
  }

  $s->Send($f->Serialize());
}

function stream_stop($node, $s) {
  $stream = new XmlNode('stream:stream');
  $s->Send($stream->Serialize('close'));
  $s->Close();
}

