<?php

function xmpp_userauth_iq_xml() {
  $funcs = array();

  $funcs['userauth_iq_init'] = array(
    'unbound' => true,
    'filters' => array(
      'tag' => 'iq',
      'options' => array(
        'type' => 'get',
      ),
      'children' => array(
        'query' => array(
          'tag' => 'query',
          'options' => array(
            'xmlns' => 'jabber:iq:auth',
          ),
          'children' => array(
            'username' => array(
              'tag' => 'username'
            ), //End of 'username' tag definition
          ),
        ), //End of 'query' tag definition
      ),
    ), //End of 'iq' tag definition
  );
  
  $funcs['userauth_iq_login'] = array(
    'unbound' => true,
    'filters' => array(
      'tag' => 'iq',
      'options' => array(
        'type' => 'set',
      ),
      'children' => array(
        'query' => array(
          'tag' => 'query',
          'options' => array(
            'xmlns' => 'jabber:iq:auth',
          ),
          'children' => array(
            'username' => array(
              'tag' => 'username',
            ), //End of 'username' tag definition
            'password' => array(
              'tag' => 'password',
            ), //End of 'password' tag definition
            'resource' => array(
              'tag' => 'resource',
            ), //End of 'resource' tag definition
          ),
        ),//End of 'Query' tag definition
      ),
    ),// End of 'iq' tag definition
  );

  return $funcs;
}

function userauth_iq_init($node, &$s) {
  $response = new XmlNode('iq');
  $response->options['id'] = $node->options['id'];
  $response->options['type'] = 'result';

  $query = new XmlNode('query', array('xmlns' => 'jabber:iq:auth'));

  $username = new XmlNode('username');
  $username->data = $node->children['query']->children['username']->data;

  $query->AddChild($username);
  $query->AddChild(new XmlNode('password'));

  $response->AddChild($query);

  $s->Send($response->Serialize());
}

function userauth_iq_login($node, &$s) {
  global $ini;

  $username = $node->children['query']->children['username']->data;
  $password = $node->children['query']->children['password']->data;

  $response = new XmlNode('iq');
  $response->options['id'] = $node->options['id'];
  $response->options['from'] = $ini['host'];

  //$result = db_query("SELECT * FROM {users} WHERE name='%s' AND pass='%s' AND status=1", $username, md5($password));
  $user = user_load(array('name' => $username, 'pass' => $password, 'status' => 1)); //db_fetch_object($result);

  if($user) {
    $response->options['type'] = 'result';

    $s->user = drupal_unpack($user);
    
    $s->jid = new JID();
    $s->jid->name = $s->user->name;
    $s->jid->domain = $ini['host'];
    $s->jid->resource = $node->children['query']->children['resource']->data;

    $s->authorized = true;
    $s->bound = true;

    modules_event('user_login', $s);
    modules_event('user_bind', $s);
  } else {
    $q = new XmlNode('error', array('code' => '401', 'type' => 'cancel'));
    $na = new XmlNode('not-authorized', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-stanzas'));

    $q->AddChild($na);
    $response->AddChild($q);
    $response->options['type'] = 'error';
  }
 
  $s->Send($response->Serialize());
}
