<?php

function xmpp_userauth_sasl_features($s) {
  if($s->authorized)
    return;

  $mechanisms = new XmlNode('mechanisms', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-sasl'));
  $digest = new XmlNode('mechanism');
  $digest->data = "DIGEST-MD5";

  $plain = new XmlNode('mechanism');
  $plain->data = "PLAIN";

//  $mechanisms->AddChild($digest);
  
  //if($s->tls)
    $mechanisms->AddChild($plain);
  return $mechanisms;
}

function xmpp_userauth_sasl_xml() {
  $funcs = array();

  $funcs['userauth_sasl_auth'] = array(
    'unbound' => true,
    'filters' => array(
      'tag' => 'auth',
      'options' => array(
        'xmlns' => 'urn:ietf:params:xml:ns:xmpp-sasl',
      ),
    ),
  );
  
  $funcs['userauth_sasl_response'] = array(
    'filters' => array(
      'tag' => 'response',
      'options' => array(
        'xmlns' => 'urn:ietf:params:xml:ns:xmpp-sasl',
      ),
    ),
  );

  return $funcs;
}

function userauth_sasl_auth($node, &$s) {
  global $ini;
  
  $data = base64_decode($node->data);
  $data = explode("\000", $data);

  if(!$data[0])
    $data[0] = $data[1];
  $username = $data[0];
  $password = $data[2];

  $user = user_load(array('name' => $username, 'pass' => $password, 'status' => 1));

  if($user) {
    $s->user = drupal_unpack($user);
    
    $s->jid = new JID();
    $s->jid->name = $s->user->name;
    $s->jid->domain = $ini['host'];

    $s->authorized = true;

    modules_event('user_login', $s);

    $resp = new XmlNode('success', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-sasl'));
    $s->Send($resp->Serialize());
  } else {
    $q = new XmlNode('failure', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-sasl'));
    $na = new XmlNode('not-authorized');

    $q->AddChild($na);

    $s->Send($q->Serialize());
  }

}

function userauth_sasl_response($node, &$s) {
}
