<?php

function xmpp_xmlevents_init() {
  _xmpp_xml_event_info();
}

function xmpp_xmlevents_new_session($s) {
  $events = _xmpp_xml_event_info();
  foreach($events as $mod => $cbs) {
    $cbs = is_array($cbs) ? $cbs : array();
    foreach($cbs as $func => $params) {
      $params['filters'] = is_array($params['filters']) ? $params['filters'] : array();
      $params['args'] = is_array($params['args']) ? $params['args'] : array();
      array_unshift($params['args'], $func, $params['auth'], $params['unbound'], $s);
	    $s->xml->RegisterHandler($params['op'], 'xmlevents_rules', $params['args'], $params['filters']);
    }
  }
}

function xmlevents_rules($node, $func, $auth, $unbound, $s) {
  $args = func_get_args();
  
  foreach($args as $k => $v) print("$k => $v\n");

  array_shift($args); // Shift off $node
  array_shift($args); // Shift off $func
  array_shift($args); // Shift off $auth
  array_shift($args); // Shift off $unbound
  array_unshift($args, $node); //Shift $node back on.
  
//  echo "$auth . {$s->authorized} . {$s->bound} . $unbound\n";
  
  if((!$auth || $s->authorized) || ($s->bound || $unbound))
    return call_user_func_array($func, $args);

  $serr = new XmlNode('stream:error');

  $cond = new XmlNode('not-authorized', array('xmlns' => 'urn:ietf:params:xml:ns:xmpp-streams'));
  $serr->AddChild($cond);

  $s->Send($serr->Serialize());
  return false;
}

function _xmpp_xml_event_info() {
  static $events;
  if(!isset($events)) {
    $events = modules_event("xml");
  }
  
  return $events;
}

